// BinaryTreeExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BinaryTreeExample.h"
#include "BinaryTreeExampleDlg.h"
#include "SimpleBinaryTree.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBinaryTreeExampleDlg dialog

CBinaryTreeExampleDlg::CBinaryTreeExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBinaryTreeExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBinaryTreeExampleDlg)
	m_ResultsBox = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBinaryTreeExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBinaryTreeExampleDlg)
	DDX_Text(pDX, IDC_RESULTS, m_ResultsBox);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBinaryTreeExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CBinaryTreeExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_DOTEST, OnDotest)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CBinaryTreeExampleDlg message handlers

BOOL CBinaryTreeExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBinaryTreeExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBinaryTreeExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBinaryTreeExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CBinaryTreeExampleDlg::OnDotest() 
{
//	DoTest();
	DoTest2(&m_ResultsBox);
	UpdateData(FALSE);
}

void CBinaryTreeExampleDlg::DoTest2(CString *pString)
{
	// create btree object
	CSimpleBinaryTree btree;
	int nMaxElems=30;
	int nFindLoop=10;
	int index=0;
	int nThreshold=0;
	CString tempStr;

	//Initialise btree and don't specify a compare function
	// cos we're going to use the default global one.
	btree.Initialise(nMaxElems,sizeof(long));
	
	//Set Allow Duplicates flag to FALSE
	btree.m_bAllowDuplicates=FALSE;

	//Get Search Method Threshold  value
	nThreshold=btree.GetSearchMethodThreshold();

	// Turn AutoResize Off
//	btree.m_bAutoResize=FALSE;

	// Increment and set the search threshold value
	nThreshold+=2;
	btree.SetSearchMethodThreshold(nThreshold);

	// Add some random numbers to the btree,
	tempStr.Format("\r\n---ADDING NEW ITEMS\r\n\r\n");
	*pString+=tempStr;
	for(int i=0;i<nMaxElems;i++){
		int x=rand()%nMaxElems;
		if((index=btree.AddItem(&x))>=0)
			tempStr.Format("allocated integer with value %d into position %d\r\n", x, index);
		else {
			switch (index) {
			case OUT_OF_MEMORY:
				tempStr.Format("NO MORE MEMORY AVAILABLE\r\n");
				break;
			case DUPLICATE_FOUND:
				tempStr.Format("DUPLICATE: where item has value %d\r\n",x);
				break;
			case TREE_IS_FULL:
				tempStr.Format("TREE FULL AT INDEX=%d\r\n",i);
				break;
			}
		}
		*pString+=tempStr;
	}

	//Find out if some values exist in the tree
	tempStr.Format("\r\n---SEARCH FOR & RETRIEVE ITEMS\r\n\r\n");
	*pString+=tempStr;
	for(i=0;i<nFindLoop;i++){
		int item=rand()%nMaxElems;
		if((index=btree.FindItem(&item))>=0){
			tempStr.Format("Found int with value %d at index %d\r\n", item, index);
		} else {
			tempStr.Format("Integer with value %d not found\r\n", item);
		}

		*pString+=tempStr;

		if(index>=0){
			//Get a pointer to the data held in the btree
			tempStr.Format("Getting pointer to data at index: %d\r\n", index);
			*pString+=tempStr;

			long *dataptr;
			if((dataptr=(long*)btree.GetItemPtr(index))!=NULL)
				tempStr.Format("Value of data referenced by dataptr=%d\r\n\r\n", *dataptr);
			else
				tempStr.Format("Got NULL Pointer. i.e. No Data Here!!\r\n\r\n");

			*pString+=tempStr;
		}
	}

	tempStr.Format("\r\nResizing tree: doubling\r\n\r\n");
	*pString+=tempStr;
	// Resize the Btree
	btree.ReSize(nMaxElems*2);

	tempStr.Format("\r\n---FIND & REMOVE EXISTING ITEMS\r\n\r\n");
	*pString+=tempStr;
	//Find out if some values still exist in the tree
	for(i=0;i<nFindLoop;i++){
		int item=rand()%nMaxElems;
		if((index=btree.FindItem(&item))>=0)
			tempStr.Format("Found integer with value %d at index %d\r\n", item, index);
		else
			tempStr.Format("Integer with value %d not found\r\n", item);
		
		*pString+=tempStr;
		// Remove elements from the btree
		tempStr.Format("Result of Removing item at index %d: %s\r\n", index,
			((btree.RemoveItem(index)) ? "OK" : "BAD INDEX"));
		*pString+=tempStr;
	}

	tempStr.Format("\r\nResizing tree: reducing by half\r\n\r\n");
	*pString+=tempStr;
	// Resize the Btree
	btree.ReSize(nMaxElems/2);

}
